package org.dromara.service.impl;

import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import org.dromara.domain.bo.SenMonitorTaskAlgorithmsBo;
import org.dromara.domain.vo.SenMonitorTaskAlgorithmsVo;
import org.dromara.domain.SenMonitorTaskAlgorithms;
import org.dromara.mapper.SenMonitorTaskAlgorithmsMapper;
import org.dromara.service.ISenMonitorTaskAlgorithmsService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 监控点任务-算法配置Service业务层处理
 *
 * @author luogang
 * @date 2024-09-19
 */
@RequiredArgsConstructor
@Service
public class SenMonitorTaskAlgorithmsServiceImpl implements ISenMonitorTaskAlgorithmsService {

    private final SenMonitorTaskAlgorithmsMapper baseMapper;

    /**
     * 查询监控点任务-算法配置
     *
     * @param taskId 主键
     * @return 监控点任务-算法配置
     */
    @Override
    public SenMonitorTaskAlgorithmsVo queryById(Long taskId){
        return baseMapper.selectVoById(taskId);
    }

    /**
     * 分页查询监控点任务-算法配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 监控点任务-算法配置分页列表
     */
    @Override
    public TableDataInfo<SenMonitorTaskAlgorithmsVo> queryPageList(SenMonitorTaskAlgorithmsBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<SenMonitorTaskAlgorithms> lqw = buildQueryWrapper(bo);
        Page<SenMonitorTaskAlgorithmsVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的监控点任务-算法配置列表
     *
     * @param bo 查询条件
     * @return 监控点任务-算法配置列表
     */
    @Override
    public List<SenMonitorTaskAlgorithmsVo> queryList(SenMonitorTaskAlgorithmsBo bo) {
        LambdaQueryWrapper<SenMonitorTaskAlgorithms> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<SenMonitorTaskAlgorithms> buildQueryWrapper(SenMonitorTaskAlgorithmsBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<SenMonitorTaskAlgorithms> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getConfigContent()), SenMonitorTaskAlgorithms::getConfigContent, bo.getConfigContent());
        return lqw;
    }

    /**
     * 新增监控点任务-算法配置
     *
     * @param bo 监控点任务-算法配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(SenMonitorTaskAlgorithmsBo bo) {
        SenMonitorTaskAlgorithms add = MapstructUtils.convert(bo, SenMonitorTaskAlgorithms.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setTaskId(add.getTaskId());
        }
        return flag;
    }

    /**
     * 修改监控点任务-算法配置
     *
     * @param bo 监控点任务-算法配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(SenMonitorTaskAlgorithmsBo bo) {
        SenMonitorTaskAlgorithms update = MapstructUtils.convert(bo, SenMonitorTaskAlgorithms.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(SenMonitorTaskAlgorithms entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除监控点任务-算法配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
